//SerialPortCommunicate.java

package bedcontrollerpackage;

/**
 *
 * @author colin
 */

import gnu.io.*;
import java.io.*;

public class SerialPortCommunicate {
  protected OutputStream out;
  protected CommPort commPort;
  protected int myservoLast = 25;
  protected int myservoDirection = 1;
  protected InputStream in;
  public String errormessage = "";
  public boolean connected = false;

  public SerialPortCommunicate(String port) {
    try { this.connect(port); }
    catch ( Exception e ) { e.printStackTrace(); errormessage="COM port error"; }
  }

  public void connect(String port) throws Exception {  //open port, enable write
    CommPortIdentifier portIdentifier = CommPortIdentifier.getPortIdentifier(port);
    if (portIdentifier.isCurrentlyOwned()) {
      System.out.println("Error: Port is currently in use");
      errormessage="COM port error";
    } else {
      commPort = portIdentifier.open(this.getClass().getName(), 2000); //2000 is TIMEOUT
      SerialPort serialPort = (SerialPort) commPort;
      serialPort.setSerialPortParams(19200, SerialPort.DATABITS_8, SerialPort.STOPBITS_2, SerialPort.PARITY_NONE);
      out = serialPort.getOutputStream();
      in = serialPort.getInputStream();
      connected = true;
    }
  }

  protected void disconnect() {
    try { out.close(); }
    catch ( Exception e ) { e.printStackTrace(); }
    commPort.close();
  }

  public void sendcommand(int command) {
    try {
      out.write(command);
    }
    catch ( Exception e ) { e.printStackTrace(); }
  }

  public int getinput() {
    int blob = -666;
    try {
      blob = in.read();
    }
    catch ( Exception e ) { e.printStackTrace(); }
    return blob;
  }
}
